﻿:namespace Latest                
⍝ Implement "Latest" as a User Command. Adapted from Ray Cannons UCMDS.
    
    ⎕ml←0 ⋄ ⎕io←1
    
    ∇ r←List
      r←⎕NS''
      r.Name←'latest'
      r.Desc←'List functions modified today'
      r.Parse←''
      r.Group←'Tools'
    ∇
    
    ∇ r←Run(Cmd Args)
      :If 0∊⍴r←Latest Args
          r←'(nothing changed today)'
      :EndIf
    ∇
    
    ∇ r←lev Help Cmd;CR
      CR←⎕AV[4]
      r←'Lists fns modified since the date (YYYYMMDD, default today) given as argument,',CR,'most-recently-changed first.'
      →lev↓0
      r←r,CR,CR,' Example:',CR,'      ]latest ' '#.foo  #.goo  #.Fa   #.dfn1 #.Fb   #.xx.Fnml'
    ∇
    
    ∇ r←Latest crit;so;dates;from;keep
      ⍝ Returns a list of fns/operators last modified
      :If 9=##.⎕NC'THIS' ⋄ from←##.THIS ⋄ :Else ⋄ from←⍎⎕IO⊃⎕NSI ⋄ :EndIf
      so←0 100 100⊤100⊥¯3↑2⊃⎕VFI crit ⋄ crit←100⊥so+(so=0)×3⍴⎕TS
      :If 0<⍴r←from listObjs 3.1 4.1
          so←⍒dates←,100⊥⍉1 1 1 0 0 0 0/2 ⎕AT↑r
          keep←crit≤dates[so]
          r←r[keep/so]
      :End
    ∇
    
      listObjs←{⍺←#
          ⎕ML←0
          1↓⊃,/' ',⍵∘{(⍕⍵)∘,¨~∘' '¨↓'.',⍵.⎕NL ⍺}¨nsTree ⍺
⍝ list objects in ⍺ space
⍝ ⍵ nameclasses ∊ 0.1×⍳100
⍝ ← fullname list all nameclass items in or below space
⍝ Phil Last ⍝ 2008-01-09 12:09
      }
 
⍝ namespace tree
⍝ ⍵ ns
⍝ ← ns and all nss below
⍝   excludes nss whose only ref is outside parent
⍝ Phil Last ⍝ 2008-04-30 00:30                                      
    nsTree←{  ⍵{⊃∇/⍺.(⍺{(0,⍵)/⍨0,(⍺≠⍵)∧⍺=⍵.##}⍎⍕'⍺',⌽⎕NL ¯9.1),⊂⍵,⍺}⍬}
    
:Endnamespace