﻿:namespace Locate

    ⎕ml←1 ⋄ ⎕io←1 ⋄ Fns← 'FFind' 'FReplace'

    ∇ r←List
      r←⎕NS¨2⍴⊂''
      r.Name←Fns
      r.Group←⊂'Tools'
      r.Parse←'12',¨⊂'L -folder= -options∊ismISM -types= -regex'
      r[1].Desc←'Returns where a string is found in files (Win)'
      r[2].Desc←'Replace occurrences of strings by others in files (Win)'
    ∇

    ∇ r←Run(Cmd Args);ct;w
      r←0 0⍴''
      'This command does not run under Unix'⎕SIGNAL 11↓⍨⎕SE.SALTUtils.WIN
     ⍝ The utility functions are in this script
      ct←⎕SE.SALT.Load'tools\code\fileUtils -tar=',⍕##
     ⍝ We'll run one of them on these folders
      :If 0≡w←⊂Args.folder
          w←⎕SE.SALTUtils.ClassFolder∘''¨';'{1↓¨(v∊⍺)⊂v←⍺,⍵}⎕SE.SALT.Settings'workdir'
      :EndIf
     
      ⍝ Is this NOT a regular epression?
      :If ~Args.regex
          Args.Arguments←'{}\.[^|]$(?*)' ''{pat←⍵ ⋄ r←1+b←⍵∊⍺ ⋄ (pat b)←r∘/¨pat b ⋄ ((≠\b)/pat)←'\'
              pat}¨Args.Arguments
      :EndIf
     
      :Select Cmd
      :Case 1⊃Fns
          w ct.showExpr¨⊂Args.((⎕IO⊃Arguments)types 1 options)
      :Case 2⊃Fns
          w ct.replExpr¨⊂Args.(Arguments,types 1 options)
      :EndSelect
    ∇

    ∇ r←lev Help Cmd;i;l1
      i←Fns⍳⊂Cmd ⋄ l1←'FILE ',i⊃'Find. ' 'Replace. '
      r←i⊃'Arg: string.' 'Arg: 2 strings; replace the first one by the other'
      r←⊂l1,' This is a WINDOWS command only. ',r
      r,←⊂'-folder  specifies a folder different than the current workdir'
      r,←⊂'-types   specifies the file types (extensions) to deal with'
      r,←⊂'-regex   the argument is a regular expression'
      r,←⊂'-options specifies whether multiline mode (M, default) or'
      r,←⊂'         single line mode (S) or case insensitive (I) is desired'
      :If lev>0
          r,←'' 'Examples:',⊂(i⊃'Find ABC' 'Replace ABC by WXYZ'),' in current .dyalog files'
          r,←⊂'  ]',(i⊃Fns),' ABC',(i=2)/'  WXYZ'
          r,←' ',⊂((i⊃'Find' 'Replace'),' insensitive syntactic ABC',(i=2)/' by WXYZ'),' in current .PHP files in \TMP'
          r,←⊂'  ]',(i⊃Fns),' \bABC\b',((i=2)/'  WXYZ'),' -opt=i -folder=\tmp -typ=php -regex'
      :EndIf
      r←↑r
    ∇



:endnamespace