﻿:Namespace findrefs

    ⎕IO←1 ⋄ ⎕ML←1 ⋄ CR←⎕AV[4]

    ∇ r←List
      r←⎕NS¨1⍴⊂⍬
   ⍝ Name, group, short description and parsing rules
      r.Name←⊂'findrefs'
      r.Group←⊂'wsutils'
      r[1].Desc←'Find References and Reference Loops'
      r.Parse←⊂' -loops  -aliases  -nolist  -root= '
    ∇

    ∇ r←Run(Cmd Line);loop;i;j;from;to;REFS;NAMES;LOOPS;root;z;ai3;COUNT
      :Select Cmd
      :Case 'findrefs'
     
          :If 0≢Line.root
          :AndIf 9=#.⎕NC Line.root
              root←#⍎Line.root
          :Else ⋄ root←##.THIS
          :EndIf
     
          ai3←3⊃⎕AI
          (REFS NAMES LOOPS COUNT)←FINDLOOPS root
          ai3←(3⊃⎕AI)-ai3
     
          r←((⍕root),': Followed ',(⍕COUNT),' pointers to reach a total of ',(⍕⍴REFS),' "refs" in ',(⍕ai3),'ms.')''
          :If ~Line.nolist
              z←↑2(↑⍣(~Line.aliases))¨NAMES
              z←((⊂'Shortest Name'),'Alias '∘,¨⍕¨¯1+1↓⍳2⊃⍴z)⍪z
              r,←↓⍕z
              r,←⊂''
          :EndIf
     
          :If Line.loops
              r,←((⍕⍴LOOPS),' loops found:')''
     
              :For i :In ⍳⍴LOOPS
                  r,←⊂'Loop #',(⍕i),': ',4↓⍕' → '∘,¨(⍕∘⊃¨loop←NAMES[REFS⍳i⊃LOOPS])~¨' '
                  :For j :In 1⌽⍳⍴loop
                      from←((1+(⍴loop)|j-2),1)⊃loop
                      to←j⊃loop
                      from←1⊃((1∊¨from∘⍷¨to)/to)~⊂from
                      r,←⊂'   ',(1⊃to),' = ',from
                  :EndFor
                  r,←⊂''
              :EndFor
          :EndIf
          r←⍕⍪r
      :EndSelect
    ∇

    ∇ r←level Help Cmd;⎕ML
      ⎕ML←1
      :Select Cmd
      :Case 'findrefs'
          r←'Follow nested references in the workspace until all references'
          r,←CR,'are found. Accepts switches:'
          r,←CR,CR,'-root=       Root namespace (default=#)'
          r,←CR,'-loops       Report reference loops'
          r,←CR,'-aliases     List all aliases for each ref found'
          r,←CR,'-nolist      Do not list namespaces (useful with -loop)'
      :EndSelect
    ∇


    ∇ (FOUND NAMES PATHS COUNT)←{name}FINDLOOPS ref;STACK;FINDPATH;COUNT
 ⍝ Find loops starting at ref
     
      :If 0=⎕NC'name' ⋄ name←,⍕ref ⋄ :EndIf
      COUNT←0
      FINDPATH←0 ⍝ 1 for FINDPATH mode
      STACK←⍬
      FOUND←⍬ ⍝ List of refs that have been found
      NAMES←⍬ ⍝ Names of FOUND refs
      PATHS←⍬ ⍝ List of refs that are known to be part of a loop
     
      name findrefs ref
      PATHS←∪PATHS
      NAMES←{⍵[⍋⊃∘⍴¨⍵]}¨NAMES ⍝ Shortest names first
      :If 0≠⍴PATHS
          PATHS←({(⍳⍴⍵)=⍵⍳⍵}{⍵[⍋↑⍵]}¨⍕¨¨{NAMES[FOUND⍳⍵]}¨PATHS)/PATHS ⍝ De-duplicate on names
      :EndIf
    ∇

    ∇ PATHS←{start}FINDPATHS ref;STACK;FINDPATH;FOUND;NAMES;TARGET
     ⍝ Find paths to ref
     
      :If 0=⎕NC'start' ⋄ start←# ⋄ :EndIf
      FINDPATH←1 ⋄ TARGET←ref ⍝ 1 for FINDPATH mode
      STACK←⍬
      FOUND←⍬ ⍝ List of refs that have been found
      NAMES←⍬ ⍝ Names of FOUND refs
      PATHS←⍬ ⍝ List of refs that are known to be part of a loop
     
      (⍕start)findrefs start
    ∇

    ∇ name findnestedrefs v;i;m;refs
     ⍝ Find refs within an array
     
      COUNT+←1
      :If 0≠×/⍴v
          :For i :In refs/⍳⍴refs←,{9=⊃⎕NC'⍵'}¨v ⍝ Ref elements
              (name fmtidx i,⍴v)findrefs i⊃,v
          :EndFor
     
          :If 0≠⍴⍴v
              :For i :In m/⍳⍴m←(~refs)∧,326=⎕DR¨v ⍝ Nested pointer arrays
                  ('⊃',name fmtidx i,⍴v)findnestedrefs i⊃,v
              :EndFor
          :EndIf
      :EndIf
    ∇

    ∇ name findrefs ref;names;mf;f;n;v;m;i
     ⍝ Manipulates FOUND, NAMES, LOOPS - see FINDREFS for details
     
      COUNT+←1
      →(ref∊⎕THIS)⍴0 ⍝ Don't include wherever this code is!
     
      :If ref∊STACK             ⍝ Loop!
          PATHS←PATHS,⊂(-(⌽STACK)⍳ref)↑STACK ⍝ Register this ref as member of a loop
      :EndIf
     
      :If (⍴FOUND)≥i←FOUND⍳ref  ⍝ Been here before!
          names←i⊃NAMES
          :If (2=+/STACK=ref)∨(1<⍴names)∧∨/{⍵≡((⍴⍵)↑name)}¨names ⋄ →0 ⍝ Coming around again?
          :Else
              (i⊃NAMES),←⊂name      ⍝ Register the name
              :If 100<⍴i⊃NAMES ⋄ ∘ ⋄ :EndIf
          :EndIf
      :Else
          FOUND,←ref
          NAMES,←⊂,⊂name
      :EndIf
     
      STACK,←ref
     
      :If '⊃'∊name ⋄ name←'(',name,')' ⋄ :EndIf
      :If 0≠⍴names←ref.⎕NL ¯2    ⍝ Variables
          names←(326=ref⍎¨'⎕DR '∘,¨names)/names ⍝ Pointer variables
     
          :For n :In names
              (name,'.',n)findnestedrefs ref⍎n
          :EndFor
      :EndIf
     
      :For n :In ref.⎕NL ¯9.1   ⍝ Check refs too :-)
          (name,'.',n)findrefs ref⍎n
      :EndFor
     
      STACK←¯1↓STACK
    ∇

    ∇ r←name fmtidx rarg;shape;i
 ⍝ Format index into ravel as index into matrix
     
      i←⊃rarg ⋄ shape←1↓rarg
      :If ('⊃'=1↑name)∧1=⍴⍴shape
          r←(⍕i),name
      :Else
          r←'[',(⍕⎕IO+shape⊤i-⎕IO),']'
          ((r=' ')/r)←';'
          r←name,r
      :EndIf
    ∇

:EndNamespace