﻿:Namespace CodeCov

    ⎕io← ⎕ML ←0 ⍝ *** DO NOT change these system variables here, only after the variables definition

⍝ === VARIABLES ===

    _←⍬
    _,←⊂' :AndIf    '
    _,←⊂' :Case     '
    _,←⊂' :CaseList '
    _,←⊂' :Continue '
    _,←⊂' :Else     '
    _,←⊂' :ElseIf   '
    _,←⊂' :End      '
    _,←⊂' :EndFor   '
    _,←⊂' :EndIf    '
    _,←⊂' :EndRepeat'
    _,←⊂' :EndSelect'
    _,←⊂' :EndTrap  '
    _,←⊂' :EndWhile '
    _,←⊂' :For      '
    _,←⊂' :GoTo     '
    _,←⊂' :If       '
    _,←⊂' :Leave    '
    _,←⊂' :OrIf     '
    _,←⊂' :Repeat   '
    _,←⊂' :Return   '
    _,←⊂' :Select   '
    _,←⊂' :Trap     '
    _,←⊂' :Until    '
    _,←⊂' :While    '
    AllStmts←↑_

⍝ 0. the :statement ID
⍝ 1. if it is an 'end' statement
⍝ 2. if it causes a branch above
⍝ 3. if it is a conditional branch
⍝ 4. if this statement is the target of a branch
⍝ 5. if the next statement is the target of a branch
⍝ 6. if this statement does NOT leave a trace in ⎕MF
⍝ 7. if this statement is an unconditional branch (like :else)

    _← ':if'        0 0 1 0 0 0 0
    _,←':elseif'    0 0 1 1 0 0 0
    _,←':else'      0 0 0 0 1 0 1 
    _,←':endif'     1 0 0 0 1 0 0
    _,←':for'       0 0 1 0 1 0 0
    _,←':endfor'    1 0 1 0 1 0 0
    _,←':continue'  0 0 0 0 0 0 1
    _,←':leave'     0 0 0 0 0 0 1
    _,←':repeat'    0 0 0 0 1 0 0
    _,←':endrepeat' 1 0 0 0 1 0 1
    _,←':until'     0 0 1 0 0 0 0
    _,←':andif'     0 0 1 0 0 0 0
    _,←':orif'      0 0 1 0 0 0 0
    _,←':while'     0 0 1 1 0 0 0
    _,←':endwhile'  1 0 0 0 1 0 1
    _,←':select'    0 0 1 0 0 0 0
    _,←':case'      0 0 1 1 0 0 0
    _,←':endselect' 1 0 0 0 1 0 0
    _,←':goto'      0 0 1 0 0 0 0
    _,←':return'    0 0 0 0 0 0 1
    _,←':trap'      0 0 0 0 0 0 0
    _,←':endtrap'   1 0 0 0 1 0 0
    CS←22 8⍴_

    _←⍬
    _,←⊂'   Control statements are not treated the same way for all APLs.      '
    _,←⊂'   Here is a list of differences between some of the main vendors.    '
    _,←⊂''
    _,←⊂'    ⊥ means the statement immediately ABOVE acts as a branch statement'
    _,←⊂'    → means it acts as a  CONDITIONAL   branch statement'
    _,←⊂'    > means it acts as an UNCONDITIONAL branch statement'
    _,←⊂'    × means it does not appears in the ⎕mf report       '
    _,←⊂'    : means is target of a branch                       '
    _,←⊂'    ⊤ means next statement is target of a branch        '
    _,←⊂''
    _,←⊂'    <CCfindbehav> is used to find the exact bevaviour.  '
    _,←⊂'    This will report statements like :else as branch statement but    '
    _,←⊂'    it is not a CONDITIONAL branch. Same for :endfor and all branch'
    _,←⊂'    stmts (e.g. :leave)                         '
    _,←⊂'    <MakeCS> is used to build CS from this data.'
    _,←⊂'    See CCinithow for details.                  '
    _,←⊂''
    _,←⊂'   APL           Dyalog                    APL+Win'
    _,←⊂'   id            DYW                       A2K         '
    _,←⊂'1  :if ⍵         →                         →           '
    _,←⊂'2  :elseif ⍵     →:                        ⊥→:         '
    _,←⊂'3  :else         ⊤>                        ⊥:⊤         '
    _,←⊂'4  :endif        ⊤                         ×⊤          '
    _,←⊂'5  :for x :in ⍵  →⊤                        ⊤once→      '
    _,←⊂'   "in" goes with the "for" statement (same as "ineach")'
    _,←⊂'7  :endfor       ⊤→                        →⊤:         '
    _,←⊂'8  :continue     >                         ×⊥          '
    _,←⊂'9  :leave        >⍝"end"+1                 ⊥→ ⍝ "end"+1'
    _,←⊂'10 :repeat       once⊤                     ×           '
    _,←⊂'23 :endrepeat    >⍝+⊤with :continue         ⊥⊤×         '
    _,←⊂'11 :until ⍵      →                         →⊤:         '
    _,←⊂'12 :andif ⍵      → ⍝ see note 1            →⊥         '
    _,←⊂'13 :orif  ⍵      → ⍝ see note 2            →⊥         '
    _,←⊂'14 :while ⍵      →:end+1                   →:end+1     '
    _,←⊂'15 :endwhile     >⊤                        ×while⊤     '
    _,←⊂'16 :select ⍵     →                         →once       '
    _,←⊂'17 :case   ⍵     →:                        →:          '
    _,←⊂'18 :endselect    at end only⊤              :⊤only if no select        '
    _,←⊂'19 :goto L       →                         →  '
    _,←⊂'20 :return       >                         ⊥× '
    _,←⊂'21 :trap ⍵       once                      NA '
    _,←⊂'22 :endtrap      ⊤                         NA '
    _,←⊂''
    _,←⊂'   Because × leaves no reference count in ⎕MF we must add a dummy     '
    _,←⊂'   statement on lines where they are used. This is only for APL+Win.   '
    _,←⊂''
    _,←⊂'   Note 1: only the statement following the last ANDIF in a REPEAT    '
    _,←⊂'   group can be the target of a branch.                               '
    _,←⊂''
    _,←⊂'   Note 2: only the statement following the last ORIF in any group    '
    _,←⊂'   can be the target of a branch.'
    _,←⊂'   Also, the line after :Until is the target of a branch in :While blocks.'
    _,←⊂''
    _,←⊂'→  The possible contructs are:                        '
    _,←⊂'   1 (12|13)* (2 (12|13)*)* 3? 4               ⍝ if   '
    _,←⊂'   5  (8|9|19|20)* 7                           ⍝ for  '
    _,←⊂'   10   (9|19|20)* ((11 (12|13)*)|23)          ⍝ repeat (continue also allowed but not included here)                              '
    _,←⊂'   14 (12|13)* (8|9|19|20)? (15|(11 (12|13)*)) ⍝ while        '
    _,←⊂'   16 17+ 3? 18                                ⍝ select       '
    _,←⊂'   21 3? 22                                    ⍝ trap (special)'
    ControlStmts←↑_

    _←0/C←⎕av[3]
    _←   'This namepace will help do code coverage of functions.'
    _,←C
    _,←C,'This will work for functions in the current namespace or for a single namespace:'
    _,←C
    _,←C,'1. Bring in the code which will reside in CodeCov (this namespace)'
    _,←C
    _,←C,'2.	use <CCinit> as in CCinit ''list of functions'' to report on code that prevents'
    _,←C,'<CC> (below) from doing its job properly. The left arg can be 0, 1 or ¯1. No value=0.' 
    _,←C,'A 0 is the same as 1 but will bomb if the fn does not meet the requirements, that is no'
    _,←C,':End statement, one control stmts per line and → as the last statement on a line.'
    _,←C,'A 1 will prepare the code by recording where branches are expected, etc.'
    _,←C,'Functions will be reformatted to allow <CC> to work properly. A backup copy of e.g.'
    _,←C,'<MyFn> will be kept in ''MyFn⍙BU''.'
    _,←C,'A ¯1 will return what the fn would look like if reformatted without actually '
    _,←C,'changing it.'
    _,←C
    _,←C,'3.	use CC ''same or subset of the list of functions'''
    _,←C,'to show lines that were not used, branched into, branches NOT taken, etc.'
    _,←C,'CC can take a list of fns from which it will grab the calling info (with ⎕MONITOR)'
    _,←C,'or take the ⎕CR of fns to the left and their calling info to the right'
    _,←C,'and produce the proper results.'
    Describe←_

    _ ←⊂'x line never executed'
    _,←⊂'→ branch always taken'
    _,←⊂'↓ branch never  taken'
    _,←⊂': label  never used'
    _,←⊂'? no label branch'
    CClegend←↑_

    Version←1.54

    ⎕ex¨ 'C_'

⍝ === End of variables definition ===

    ⎕IO ⎕ML ⎕WX ←0 2 0

    ∇ r←APL;⎕IO
     ⍝ Find the APL we're in
      ⎕IO←0
      r←5 3⍴'SAMSAXDYWA2KAPX'
      r←r[21 251 245 6 91⍳⎕AV⍳'←';]
    ∇

    CCunBranchStmts←':Else' ':endrepeat' ':endwhile' ':continue' ':leave' ':return',(APL≢'DYW')/⊂':endfor'

    CCzone←2 ⍝ how many lines to show before and after problems

    ∇ cc←{CRs}CC RA;n;any;bg;bi;bo;br;cba;cs;lab;live;nnu;nu;ons;r;rem;F;Fn;⎕IO;⎕ML;f;hits;i;lb4;cbr
     ⍝ Produce code coverage report for fns.
     ⍝ 'CRs' is ⎕cr of fn and flags. 'RA' is list of line counts.
     ⍝ It can be called monadically with fn names instead.
     
      cc←1 1⍴⊂CClegend
      ons←'.',⍨0⊃⎕NSI
      :If live←0=⎕NC'CRs'
          Fn←CCcut{⍵/⍨b⍲1⌽b←' '=⍵},' ',⊃RA
          CRs←,⍎,⍕(⊂',(⊂',ons),¨Fn,¨⊂'⍙CR)'
      :Else
          RA←{1∊⍴⍴⍵:⍵ ⋄ ⍵[;1]}¨RA ⋄ Fn←⍬ ⋄ CRs←,CRs
      :EndIf
     
     While1:→(⍴CRs)↓EndWhile1
      f←⊃''⍴CRs ⋄ n←⊃''⍴RA ⋄ →live↓l10
      {}'monitoring off'=⍳×⍴n←(⎕MONITOR ons,⊃''⍴Fn)[;1]
     l10:lab←f[;1] ⋄ cbr←'→'=br←f[;2] ⋄ bg←f[;3]≠'*'
      f←⍴r←0/F←0 4↓f
      nnu←1⌽nu←n=0 ⍝                 not used & next not used
      r←r,' x'[nu∧bg]          ⍝     lines not executed
     
     ⍝ Following are (some "controlled") branches
      bi←1,1↓n>¯1⌽n ⍝                branched in
      bo←0,⍨2>/n
      r←r,' →'[bg∧cbr∧nnu>nu]      ⍝ always taken (line used, next NOT used)
     
     ⍝ A branch is never used if it has an equal (or smaller) execution times
      r←r,' ↓'[nu<cbr∧n≤1⌽n] ⍝       never taken
      r←r,' :'[bg∧bi<lab=':'] ⍝      all labels should be used
      f←bo∧br=' '                  ⍝ branch out without a branch statement?
      r←r,' ?'[f∨(≠/2↑n),1↓bi>lab≠' '] ⍝ branched to w/o label
      hits←f←1,1↓r∨.≠' '           ⍝ oddnesses
      :For i :In 1+⍳CCzone
          hits←hits∨i{(s↑(-⍺)⌽v)∨(s←⍴⍵)↑⍺⌽v←⍵,{0}¨⍵}f
      :EndFor
      f←('P⍞[⍞Q⍞]⍞LI5'⎕FMT⍳1↑⍴F),F ⍝ add line nos
      r←r,' ',(⍕((1↑⍴n),1)⍴n),' ',f
      :If CCzone>0
          lb4←hits<1↓hits,0     ⍝ the line before each group of hits
          bo←lb4>hits<¯1↓0,hits ⍝ those to mark as [...]
          n←''⍴⌽⍴r              ⍝ width of r
          r[bo/⍳⍴bo;]←(+/bo)n⍴n↑'[...]'
          r←(hits∨lb4)⌿r        ⍝ keep the hits and the line before
      :EndIf
     
      cc←cc⍪⊂'∇'⍪r
      CRs←1↓CRs ⋄ Fn←1↓Fn ⋄ RA←1↓RA
      →While1
      ⍝
     EndWhile1:
    ∇

    ∇ r←{b}CCcut array;⎕ML;drop
      ⎕ML←1 ⋄ ⍎(drop←0=⎕NC'b')/'b←array=1↑array'
      r←drop↓¨b⊂[⎕IO]array
    ∇

    ∇ r←CCenlist r
      →(⍴r)↓0
      r←⊃,/r
    ∇

    ∇ ids←CCextractids mat;⎕IO;b;rb;i;lav;stm
     ⍝ Extract :IDs from MATrix
      ⎕IO←0 ⋄ rb←∨/b←' APL '⍷mat ⋄ i←rb⍳1
     ⍝ The line with 'APL' is the start of the interesting information
      i←b/⍳⍴b←b<¯1⌽b←mat[i;]=' '    ⍝ that line also shows how
      mat←(2↑2+rb⍳1)↓mat[;⍳i[1]]    ⍝ all the text is divided
      mat←(mat∨.=':')⌿mat           ⍝ these are the row with :statements
      b←0≠ids←⍎,' ','0',mat[;⍳i[0]] ⍝ AND ids (a number)
      lav[(⎕AV⍳'A')+⍳26]←26↑(⎕AV⍳'a')↓lav←⎕AV
      mat←lav[⎕AV⍳b⌿mat]            ⍝ ensure lowercase
      ids←⊂b/ids                    ⍝ the numbers (IDs)
      i←-b⊥¨b←' '=mat←⊂[1](0,i[0])↓mat
     ⍝ Special case for 'else' to differentiate from 'elseif'
      stm←i↓¨mat ⋄ stm[stm⍳⊂':else']←⊂':Else'
      ids←ids,⊂stm
    ∇

    ∇ r←{fmt}CCfindbehav c;tests;⎕IO;i;ids;stmts;b;⎕ML;e
     ⍝ Determine how the :stmts behave in this APL
     ⍝ Result is ID, BranchBEFORE, IsBranch, IsTarget, Is1+Target, NotUsed
      ⎕IO←1 ⋄ ⎕ML←2
      (ids stmts)←CCextractids c
      r←CCgencombs c      ⍝ all the various possibilities
      tests←(⊂ids)⍳¨⊃,/r  ⍝ as indices
      r←⊃⍪/r←CCteststmts¨tests⊃¨¨⊂⊂stmts ⍝ perform all tests
      i←⍋tests←⊃,/tests ⋄ b←tests≠¯1↓0,tests←tests[i]
     ⍝ Gather results
      i←¯1↑⍴r←⊃∨⌿¨b CCcut r[i;] ⋄ r[;i-1]=←0 ⋄ i←b/tests
      e←1∊¨(⊂':end')⍷¨stmts[i]
      stmts←(¯1+b⍳¨' ')↑¨b←stmts[i]
      r←stmts,e,r
      :If 0≠⎕NC'fmt'
      :AndIf fmt
          r←(⊃stmts),' ⊥→:⊤×>'[1+1 2 3 4 5 6×[2]0 2↓r]
      :EndIf
    ∇

    ∇ r←CCgencombs c;b;E;⎕IO
     ⍝ Generate all Combinations of paths
      E←⊂⍳⎕IO←0
      :If 2∊⍴⍴c
          c←(2↑1+c[;0]⍳'→')↓c ⍝ '→' starts the definitions
          r←CCgencombs¨⊂[1](c∨.≠' ')⌿c
      :Else
          b←b⍲1⌽b←' '=c←(c⍳'⍝')↑c
          c←1↓b/c           ⍝ trim ends
          c←c~'+'           ⍝ min 1
          c←' ' '∘.,'txtpreplace c
          c[b/⍳⍴b←'|'=c]←',' ⍝ catenate
          c←'(\(?([0-9]+,?)+\)?)\?' '{E,\1}'txtpreplace c ⍝ add ⍬ to ?
          :While '*'∊c
              c←'\(([∧()]*)\)\*' '{E,\1}'txtpreplace c
          :EndWhile
          b←c∊'{}' ⋄ c[b/⍳⍴b]←'()'['{}'⍳b/c]
          r←,⍎c
      :EndIf
    ∇

    ∇ r←CCinithow
      r←2 2↓⎕CR'CCinithow'
⍝ The functions will be checked for conformance with <CC> requirements as per the left arg:
⍝ If  1 they will be fixed by removing 'bad' ⋄s (and a backup taken in 'fn∆BU').
⍝ If  0 and a fn needs to be fixed an error will be signalled.
⍝ If ¯1 they will be fixed and the fix returned - this is useful when you want to see what changes are made
⍝
⍝ The checks made here are for → and control statements followed by ⋄
⍝ and → followed by label on next line (the 2 statements must be separated).
⍝
⍝ On some systems like APL+Win full comment lines should have a NOOP statement
⍝ inserted BEFORE the ⍝ on the same line because comments don't count in those systems.
⍝ Some control statements are considered as conditional branches (e.g. :Until)
⍝ and others as unconditional (e.g. :Else).
⍝
⍝ The definition of all control statements is kept in 'ControlStmts',
⍝ CS is a compiled version of it and is used here instead.
⍝ It is built by doing CS←CCfindbehav ControlStmts
⍝ It contains
⍝ 0. the :statement ID
⍝ 1. if it is an 'end' statement
⍝ 2. if it causes a branch above
⍝ 3. if it is a conditional branch
⍝ 4. if this statement is the target of a branch
⍝ 5. if the next statement is the target of a branch
⍝ 6. if this statement does NOT leave a trace in ⎕MF
⍝ 7. if this statement is an unconditional branch (like :else)
⍝
⍝ This fn will save a copy of the CR of the (modified) fn and its line flags
⍝ in variable 'fn∆CR'. Those flags will be
⍝ → branch  on this line (at the end)
⍝ ⍝ no code on this line (comment or empty line)
⍝ : label   on this line or "branched to" line
⍝ * this line not to be taken into account
⍝
⍝ Notes:
⍝ 1. in Dyalog line 1 is executed first and line 0 is [unless trapped] executed LAST
⍝ 2. the last :ORif stmt's next line is the target of a branch
    ∇

⍝ To do:
⍝ make it work with Dfns (use ⎕profile)
⍝ allow skipping diamonized lines (e.g. :if ⋄ ⋄ :end
⍝ stop enforcing no :end
⍝ use 'lf' already masked for body

    ∇ new←{fix}CCinit fn;b;bad;body;bp1;br;bto;cs;dia;el;ell;end;lab;labels;lbi;level;lf;line;lpb;modified;n;nb;ons;orig;skip;t;DEL;F;Fn;⎕IO;EBT;HW;if;⎕ML;epos;block;C;B;D;U;nl;cor;dfn;list;tmpns;sqz;NU
     ⍝ DanB 1999-2012 Initialize fns to produce Code Coverage report.
     ⍝ Rarg is a list of names of functions to do code coverage on.
     ⍝ Result: pairs of function name and its flags, for each function in the list if fix≠0.
     ⍝ See variable CCinithow for Larg and details.
      if←/⍨
      new←0 2⍴⎕IO←0 ⋄ DEL←⎕AV[0] ⋄ tmpns←⎕NS''
      ⎕ML←2 ⋄ ons←'.',⍨NU←0⊃⎕NSI ⍝ Original NameSpace
      sqz←{1↓(b⍲1⌽b←t=' ')/t←,' ',⍵}
     
      ⍎(0=⎕NC'fix')/'fix←0'             ⍝ no fix by default - bombs if fn not normalized
      :If list←1=≡fn←1/fn               ⍝ simple means fn list
          fn←sqz fn                     ⍝ can be a matrix or char vector
      :AndIf 9=⌊n←⎕NC⊂cs←ons,fn         ⍝ is this a ns?
          cs←⍎cs ⋄ ons,←fn,'.' ⋄ fn←sqz cs.⎕NL 3 4
      :AndIf ~list←n≠9.4                ⍝ a Class
          fn←CCclassfns ⎕SRC cs         ⍝ there are limitations to what we can do with this
      :EndIf
     
     ⍝ NOTE: no control statement were used originally throughout the CC fns.
     ⍝ This was to cover the APLs that do not support them.
     
     While1:→(⍴,fn)↓EndWhile1           ⍝ take left justified CR
      :If ~list
          n←tmpns.⎕NC⊂Fn←tmpns.⎕FX F←orig←0⊃fn ⋄ tmpns.⎕EX Fn ⋄ →Nextfn if 0.1≠1||n
      :Else
          →Nextfn if 0.1≠1||⎕NC⊂Fn←ons{⍵,⍨('#'≠1↑⍵)/⍺}(fn⍳' ')↑fn ⍝ Tfns only for now
          F←orig←⎕CR Fn
      :EndIf
      (body dfn)←CCbody F←F⍪(1↓⍴F)↑'⍝'  ⍝ body of fn and dfns mask
     
     ⍝ We need to work with the lowercase version of the :elements and
     ⍝ make sure there is no conflict between some of them, e.g. :else/:elseIf.
      t←CS[;0],HW←,':' ':end'∘.,'hold' 'with'  ⍝ those blocks in DYW only
      lf←t CClower(⊂F),(⊂body)          ⍝ 'lf' is the fn "lowered", CS is already lower
      cs←CS[;0] ⋄ cs[cs⍳⊂':else']←⊂':Else'
     
     ⍝ Control statements always have a space before the colon
     ⍝ and labels are NOT always immediately followed by a space in Dyalog.
     ⍝ No label and control stmt is allowed in the same statement in APLWin.
     
     ⍝ Do we need to remove diamonds?
      →(modified←1∨.<n←+/D←1,body∧lf∊'⋄')↓l20 ⍝ any ⋄?
      C←body∧∨⌿⊃(cs,⊂':end ')⍷¨⊂lf ⋄ B←body∧'→'=lf ⍝ where :Cstmts and → occur in body
      →(modified←0<+/br←,0,C∨B)↓l20     ⍝ any branch or :stmt at all?
      br←(t←,D)CCorred br               ⍝ where all occur in ⋄s
      b←⊃,/n↑¨1                         ⍝ the # of ⋄ per line
      el←(B←b⊂t CCorred,0,B)≡¨(-n)↑¨1   ⍝ pure → at the end of a line is OK
      dia←b⊂br                          ⍝ ⋄s regrouped per line
      el←el∧B≡¨dia                      ⍝ pure → only valid where no CS present on line
      bad←(dia∊⊂,1)⍱el∨0∧.=¨dia         ⍝ and only 1 or none is OK
      →(modified←∨/bad)↓l20
      ('<',Fn,'> contains diamonds on lines ',⍕bad/⍳⍴bad)⎕SIGNAL fix↓11
      F←0⌿lf
     ⍝ There are diamonds, and we know there are cases where
     ⍝ there is a branch before the LAST ⋄ of each line
     
     While11:→(1∊bad)↓Endwhile11
     ⍝ We split the offending lines by separating the CS or splitting after a →
      n←bad⍳1 ⋄ t←D[n;]\(n⊃B){1,1↓(⍵>⍺)∨¯1↓0,⍵}n⊃dia
      F←F⍪lf[⍳n;]⍪t CCundia lf[n;] ⋄ t←2↑n←n+1
      D←t↓D ⋄ lf←t↓lf ⋄ dia←n↓dia ⋄ B←n↓B ⋄ bad←n↓bad
      →While11
     
     Endwhile11:F←F⍪lf                  ⍝ whatever remains...
      F←(0,-b⊥b←' '∧.=F)↓F              ⍝ drop last white columns
      body dfn←CCbody lf←F              ⍝ we work with the lowercase version
     
     ⍝ Check that no :end statement appears - they should all be matched
     ⍝ appropriately, i.e. :for ←→ :endfor
     ⍝ We can make amends by replacing all ':end's by their appropriate counterparts:
     
     l20:lab←∨/t←<\body∧':'=lf     ⍝ lines with labels
      lab←lab\¯1≠∊⎕NC¨(↓~∨\lab⌿t)/¨↓lab⌿lf
      lab←t∧[0]lab
      end←(⊂':end'),2↓HW,CS[;1]/cs      ⍝ all the :end statements already lowercase
      block←':',¨4↓¨1↓end               ⍝ various Block types
      t←∨/body∧b[0;;]>∨⌿1 0 0↓b←⊃lab∘<¨end⍷¨⊂lf ⍝ look for :end
      →(1∊t)↓l30
      ⍝ We found :end statements. This is not good.
      t←'<',Fn,'> contains ":end" statements on lines ',⍕t/⍳⍴t
      t ⎕SIGNAL fix↓11  ⍝ If we do not wish a result we then signal the case.
     ⍝ Otherwise we try to fix:
      b←∨⌿b
      b←,0,body∧b∨':until'⍷lf           ⍝ where the :ENDs are
      t←,0,body∧⊃∨/block⍷¨⊂lf           ⍝ where the blocks start
      n←level<¯1⌽level←(+\t)-+\b
      t←,DEL,lf ⍝ DEL is in front of each line to cut later
      bad←~t[4+epos←n/⍳⍴n]∊'abcdefghijklmnopqrstuvwxyz' ⍝ those are the bad 'end's - find their start
      epos←¯1+bad/epos
      nb←epos-b⊥¨b←level[epos]≤¨epos↑¨⊂level ⍝ the start pos of each block
      n←'d',¨1↓¨block[(3↑¨block)⍳⊂[1]t[nb∘.+⍳3]] ⍝ don't replace the ':en'
      t[epos+4]←n ⋄ t←⊃,/t
      nb←'⍝'=lf←⊃1↓¨(DEL=t)CCcut t
      (body dfn)←CCbody lf              ⍝ body of fn again
     
    ⍝ At this point all :struct and → are 1 per line, :struct at the beginning, → at the end
     l30:el←((+/∧\' '=lf)⌽lf)[;0]∊' ⍝'  ⍝ empty lines
     ⍝ See CCinithow for CS definition
      B←⊃cs⍷¨⊂lf ⋄ body←body>(⍴body)↑lab
      bad←∨/body∧∨⌿(∧/CS[;3 5])⌿B       ⍝ don't warn about branch out followed by branch in
      br←body∧(lf='→')∨∨⌿CS[;3]⌿B       ⍝ pure branch out
      br←∨/br∨1⌽body∧∨⌿CS[;2]⌿B         ⍝ impure branches (branches above)
      br←br+2×∨/body∧∨⌿CS[;7]⌿B         ⍝ unconditional branches out
     ⍝ Lines branched to.
     ⍝ This is a bit tricky: :Until is not usually branched to unless :Continue is used
     ⍝ We check that its :While or :Repeat block contains one before stating it is branched to.
     ⍝ For this we need to know the :Level :
      nl←⍴bto←∨/body∧∨⌿CS[;4]⌿B         ⍝ lines branched to
      C←∨/body∧':continue'⍷lf
      end←':',¨'end'∘,¨1↓¨block←':while' ':repeat'
      level←+\∨/body∧⊃∨/block⍷¨⊂lf      ⍝ max 1 of these per line
      level←level-+\∨/body∧⊃∨/b←(end,⊂':until')⍷¨⊂lf
      →((1∊C)∧1∊U←∨/↑⌽b)↓l50            ⍝ do we have a :Continue and a :Until?
      n←level[¯1+epos←U/⍳⍴U]
      b←nl{⍺↑⌽∧\⌽⍵}¨n≤¨epos↑¨⊂level     ⍝ each block
      bto∨←U\1∊¨C∘∧¨b\¨n=b/¨⊂level      ⍝ is :Continue in it?
     l50:
     ⍝ Lines branched after
     ⍝ This is also tricky: :Until has a "branched after" line in :While blocks but this may be wrong
     ⍝ when a series of :OrIf follows. This should be checked for. Same for :Ifs
      bp1←¯1↓0,∨/body∧∨⌿CS[;5]⌿B        ⍝ other (following) lines branched to
      block←':elseif' ':if' ':while' ':repeat'
      →(1∊D←∨/body∧[1 2]⊃block⍷¨⊂lf)↓l80
      →(1∊C←∨/body∧':orif'⍷lf)↓l80      ⍝ any :OrIf to do?
     ⍝ :If
      level←(+\D[1;])-+\end←∨/body∧⊃∨/':endif' ':else'⍷¨⊂lf
      n←level[¯1+epos←end/⍳⍴end]
      b←nl{⍺↑⌽∧\⌽⍵}¨n≤¨epos↑¨⊂level     ⍝ each block
      bp1∨←¯1↓0,⊃∨/{⌽<\⌽C∧⍵}¨b\¨n=b/¨⊂level
     ⍝ :ElseIf
      level←(+\D[0;])-+\end
      n←level[¯1+epos]
      b←nl{⍺↑⌽∧\⌽⍵}¨n≤¨epos↑¨⊂level     ⍝ each block
      bp1∨←¯1↓0,⊃∨/{⌽<\⌽C∧⍵}¨b\¨n=b/¨⊂level
     ⍝ :While
      level←(+\t←∨⌿1 0↓D)-+\end←U∨∨/body∧⊃∨/':endwhile' ':endrepeat' 'endif'⍷¨⊂lf
     ⍝ There are 2 parts for :While: the part after the :While and the part after the :Until as
     ⍝ both can have :OrIfs
     ⍝ Part I
      n←level[¯1+epos←end/⍳⍴end]
      b←nl{⍺↑⌽∧\⌽⍵}¨n≤¨epos↑¨⊂level     ⍝ each block
      bp1∨←¯1↓0,⊃∨/{⌽<\⌽C∧⍵}¨block←b\¨n=b/¨⊂level
     ⍝ Part II, this time the level is the one that follows
      cor←{u l o←⍵ ⋄ ~1∊u:u ⋄ ⌽<\⌽o∧l=l[i←u⍳1]}
      →(1∊n←U∧end\1∊¨D[2;]∘∧¨block)↓l70 ⍝ only :While blocks
      b←∊cor¨⊂[0]⊃(1,1↓t)∘⊂¨n level C
      bp1∨←¯1↓0,b
     l70:
      →(1∊n←U∧end\1∊¨D[3;]∘∧¨block)↓l80 ⍝ only :Repeat blocks
      b←∊cor¨⊂[0]⊃(1,1↓t)∘⊂¨n level C
      bp1∨←¯1↓0,b
     l80:
     ⍝ In some cases the same :statement is used both as a branch out and followed by branch in.
     ⍝ This makes it impossible to "cover check" properly and inserting a fake line doesn't help.
     ⍝ For some APLs, lines without code are NOT reported executed,
     ⍝ even those with labels. We should account for that.
      ell←∨/lab
      n←1++/b←∧\':'≠t←ell⌿lf            ⍝ label space
      b←,b ⋄ labels←'→',¨1↓¨(nb=' ')CCcut nb←(b⍲1⌽b←nb=' ')/nb←' ',b\b/,t
      lbi←ell∨bp1∨bto                   ⍝ all lines branched into
     
     ⍝ Find which branches are unconditional
     ⍝ also works when →lab is last stmt
     ⍝ a regex for this would be (→| :goto )(\d+|labels)({⍺}|⊣|,)?
      B←(∨/t)∧∧/(b∧t<∨\t←(b←body)∧'→'=lf)≤D←lf∊⎕D ⍝ there is only 1 per line
      B←B∨(∨/t)∧∧/(b∧(≠\¯6⌽t)<∨\t←b∧':goto '⍷lf)≤D
      B←B∨∨/body<⊃∨/(-⍴¨labels)⌽¨labels⍷¨⊂lf
      br←br⌈2×B∨∨/body<⊃∨/(-⍴¨t)⌽¨(t←':goto '∘,¨1↓¨labels)⍷¨⊂lf
     
     ⍝ Find lines that should not be reported (Dyalog only)
      skip←,dfn[;¯1+¯1↑⍴lf] ⍝ Dfns
      skip←skip∨(t←¯1↓1,br=2)CCandscan el>lbi
      ⍝ The line following and :EndIf can be skipped if there is no label or branch
      skip←skip∨(ell∨br>0)<¯1⌽b←∨/body∧⊃∨/':endif' ':endselect' ':endtrap'⍷¨⊂lf
      skip←skip∨b∧t ⍝ :end just after a pure branch is ignored
     
     ⍝ Branching before a label prevents from determining if the label is
     ⍝ being branched to (same out of the branch as into the label for ex).
      lpb←ell∧¯1↓0,∨/body∧⊃∨/'→' ' :goto '⍷¨⊂lf  ⍝ Line Preceded by Branch
      t←(b←∨/lpb)/'<',Fn,'> contains branches followed by labels on lines ',⍕lpb/⍳⍴lpb
      modified←modified∨b
      t ⎕SIGNAL 11 if modified∧0=fix
      ⎕←(b,⍴t)⍴t
     ⍝ Put flags with fn
      t←lbi∧1+ell<¯1⌽∨/body∧':Else'⍷lf  ⍝ lines after :Else are NOT considered branched in (;) unless a label exists
      lf←(el\'⍝'),' :;'[t],' →>'[br],(skip\'*'),lf ⍝ columns of 4 flags
     
     ⍝ Insert a line between a pure branch and a label
      →EndIf3 if~∨/b←lpb
      t←1⌽~¯1⌽≠\(1+b)/b             ⍝ create expand mask
      lf←t⍀lf                       ⍝ expand
      lf[i←b/⍳⍴b←~t;3]←'*'          ⍝ mark lines to be skipped
      lf[i;4]←'⍝' ⋄ lf[i;5]←'⋄'
      modified←1
     
     ⍝ Remove final null statement if line before has no branch
     EndIf3:modified←modified≥b←(</'*:'∊1 0↓t)⍱'→'∊t←¯2 4↑lf
      ('<',Fn,'> needs an extra line at the bottom')⎕SIGNAL 11 if b<fix=0
      lf←(-b,0)↓lf
      →(modified∧fix=1)↓EndIf4
      n←⍎NU{'.'∊⍵:⍵↓⍨-1+⊥⍨'.'≠⍵ ⋄ ⍺}b←Fn,'⍙BU'
      ⍎(0=⎕NC b)/b,'←orig' ⍝ take a backup copy?
      n←n.⎕FX 0 4↓lf
     EndIf4:→(list∧fix>¯1)↓Else5
      ⍎Fn,'⍙CR←lf'
      b←(⍳1↑⍴lf)⎕MONITOR Fn
      →Nextfn
     
     Else5:new←new⍪(⊂Fn),(⊂lf)
     Nextfn:fn←((1+fn⍳' ')*list)↓fn ⋄ →While1
     
     EndWhile1:
    ∇
    
    ∇ z←a CCandscan b ⍝ Partitioned AND Scan
      z←~≠\a\z≠¯1↓1,z←(a←a≥b)/b
    ∇

    ∇ fns←CCclassfns src;dels;start;end
     ⍝ Return all the code of each fn/op in a class whose source is given
      →0↓⍨∨/dels←'    ∇'∘≡¨5↑¨src{⍺}fns←0⍴⊂0 0⍴''
      start←dels\≠\dels/dels
      end←start⊂dels
      fns←end{⊃(5×'     ' '    ∇'∊⍨5↑¨l)↓¨l←(~∨\0,1↓⍺)/⍵}¨start⊂src
    ∇

    ∇ z←a CCorred b
    ⍝ Partitioned OR Reduction
      z←(z/1⌽z←(a∨b)/a)≤a/b
    ∇

    ∇ r←cs CClower s;⎕IO;n;i;rc;ls;c;mask;lc
     ⍝ DanB return lowercase of '0⊃s' where cs exist.
     ⍝ Rarg is textmat & boolmask where code is.
     ⍝ Larg is all the possible :statements already lowercased (*)
     ⍝ Work for rank ≤2 '0⊃s'
      ⎕IO←0 ⋄ mask←,0,⊃s[1] ⋄ rc←(-⍴rc)↑0 1+rc←⍴s←⊃s[0]
     ⍝ Lower 's' into 'ls'; 'lc' is lowercase of ⎕AV.
      lc[(lc⍳'A')+⍳26]←26↑(lc⍳'a')↓lc←⎕AV
     ⍝ Use lowercase version to search (ls), replace in 's'.
      n←⍴ls←,lc[0,⎕AV⍳s] ⋄ s←,⎕AV[0],s
      i←0 ⋄ cs←cs,(⊂':else'),(⊂':end') ⍝ ensure those are there
     l10:→(i=⍴cs)⍴l99
      r←((mask∧c⍷ls)/⍳n)∘.+⍳⍴c←⊃cs[i] ⋄ s[r]←(⍴r)⍴c
      i←i+1 ⋄ →l10
     
     l99:
     ⍝ * special case: else and elseif are similar;
     ⍝ to differenciate them we change else to Else
      n←⍴i←i/⍳⍴i←mask∧(':else'⍷ls)>':elseif'⍷ls
      s[i+1]←'E' ⍝ make 'else' into 'Else'
      r←((-⍴rc)↑1)↓rc⍴s
    ∇

    ∇ R←{P}CCltscan V;M
     ⍝ Partitioned <\
      M←P∨V∧∨\P
      R←(V∧P)∨M\R>¯1↓0,R←M/V
    ∇

    ∇ cr←fnname CCmakefn list;drop;args;b;⎕ML;⎕IO;i;a;for;n
     ⍝ Create a fn from a list of :statements  newcs
      drop←-a←'⍵'∊¨list
      ⎕IO←1 ⋄ ⎕ML←2 ⋄ args←(+/a)⍴'ABCDEFGHIJ'
      fnname←fnname,' args;null;x;t',CCenlist';',¨args
     ⍝ Reverse test after :until
      b←∨\(4↑¨a/list)∊⊂':unt' ⋄ n←b\'~'
      list←((':'≠,↑1↑¨list)⍴¨':'),¨(drop↓¨list),¨a\n,¨(⊂'0<t ∆ '),¨args,¨(⊂'←¯1+t←'),¨args
     ⍝ Check the :for statement
      list[⍳':for'≡4↑1⊃list]←⊂':for x :in ⍳A'
      list←,(list,[1.1]n),n←⊂'null'
     ⍝ Prevent looping forever with :endrepeat
      :If 1∊b←(7↑¨list)∊⊂':endrep'
          list[¯2+b⍳1]←⊂'→(x←x-1)↓l'
      :EndIf
     ⍝ Mod line for :trap atfer for 1st null stmt
      :If 1 0 1≡3↑(5↑¨list)∊':trap' ':Else'
          list←list[⍳2],(⊂'t←÷A'),2↓list
      :EndIf
      args←'null←0 0⍴x←3',⍕(0<⍴args)/'⋄(',(CCenlist' ',¨args),')←args'
      cr←⊃fnname args,list,⊂'l:null ⍝ last'
    ∇

    ∇ R←S CCorscan P;T
     ⍝ Partionned ∨\
      S←S∨P ⋄ R←≠\S\T≠¯1↓0,T←S/P
    ∇

    ∇ CCreset;i;v;⎕IO;del;x
     ⍝ Reset all definitions: remove all ⍙BU and ⍙CR variables and redefine fns
      ⎕IO←1
      ⎕CS ⎕IO⊃⎕NSI ⍝ return to caller env
      i←¯3↑⍳¯1↑⍴v←(-+/∧\' '=⌽v)⌽v←⎕NL 2
      →(1∊del←v[;i]∧.='⍙BU')↓l20
      x←÷~1∊⊃x←⎕FX¨⍎¨⊂[2]del⌿v
     l20:del←del∨v[;i]∧.='⍙CR'
      (⍕+/⎕EX del⌿v),' objects deleted'
    ∇

    ∇ {r}←{args}CCteststmts stmts;cr;f;⎕IO;apl;col;n;sink;ex;bi;bo;a;nla;∆;ml;row;b;ubs
     ⍝ Run a series of tests on stmts
      ⎕IO←0
      :If nla←0=⎕NC'args'
          args←⊂[1]2×⍉(n⍴2)⊤⍳2*n←+/'⍵'∊¨stmts
      :Else
          args←⊂args
      :EndIf
      sink←⎕FX cr←'f'CCmakefn stmts
      r←((⍴stmts),6)⍴0
      →(0∊⍴n←(row←n/⍳⍴n←':'=cr[;0])∘.+2 2⍴¯1 0 0 1)⍴0
      ubs←∨/⊃∨/CCunBranchStmts⍷¨⊂cr[row;]
      sink←⎕FX(1,⍴a)⍴a←'l←l ∆ r' ⍝ <lev> fn
      apl←0 ⍝((4 3⍴'DYWA2KAPXSAX')∧.=APL)⍳1
      ml←apl⊃(⍳1↑⍴cr)1 ⋄ col←1 2[apl]
      :For a :In args
          sink←ml ⎕MONITOR'f'
          f a
          ex←(⎕MONITOR'f')[;col]
          :If ~nla
              ⎕←cr,ex→0
          :EndIf
     ⍝ See if this is a branch out
          bo←>/ex[n]
     ⍝ or a branch in for line and following one
          bi←</ex[n]
          b←bo,bi
     ⍝ Make sure conditional branches are noted as such
          b[;1]>←ubs
          r←r∨(b,0<ex[row]),ubs
      :EndFor
    ∇

    ∇ (b d)←CCbody s;c;t
     ⍝ Find where the body of the fn (s) is and the Dfns
      t←≠\s=''''  ⍝ text: in APLWin account for "
      c←∨\t<'⍝'=s ⍝ find comments
      b←c⍱t       ⍝ body of fn
      b←b>⌽∧\⌽b≤s∊' ⋄' ⍝ don't include trailing spaces & ⋄s
      d←(⍴s)⍴0<(+\,b∧'{'=s)-+\,b∧'}'=s
      b←b>d       ⍝ body does not include Dfns
    ∇

    ∇ block←D CCundia line;n;len;sp
     ⍝ Split a line of statements at the diamonds
     ⍝ D is where the offending ⋄s are.
      len←''⍴⍴line ⋄ n←+/D              ⍝ number of statements
      sp←(0,1↓n⍴¯1++/∧\' '=line)↑¨' '   ⍝ spacing for new lines
      block←⊃len↑¨sp,¨(1↓¨D⊂' ',line),¨(~⌽n↑1)/¨⊂'⍝⋄'
    ∇

    ∇ CS←{apl}MakeCS tab;iv;ids;⎕IO;nc;end;bv;CStable;csl;⎕ML;msk;cons;col;ans
     ⍝ Create variable 'CS' from 'ControlStmts'
     ⍝ 'ControlStmts' is a free format character matrix of :controlstatement followed by style for each APL
     ⍝ Row with 'id' is APL ids, rows starting with : are styles' data
      ⎕IO←0 ⋄ ⎕ML←2
      ⍎(0=⎕NC'apl')/'apl←APL'
      ans←(csl←tab[;0]∊'123456789')⌿tab
      nc←+/∧\' '≠CStable←(+/∧\ans≠':')⌽ans
      col←end>¯1⌽end←' '≠ids←,(∨/' id '⍷' ',tab)⌿tab
      col←col/⍳⍴col ⍝ id+:stmts start
      bv←ids[col∘.+⍳3]∧.=apl
      'unknown APL'⎕SIGNAL(1∊bv)↓11
      iv←col[iv]+⍳-/(col,⍴ids)[1 0+iv←bv⍳1]
      msk←∨\'⍝'=cons←csl⌿tab[;iv]
      end←CStable[;⍳4]∧.=':end'
      bv←end,⍉∨/msk<[1 2]'⊥→:⊤×>'∘.=cons
     ⍝ '×'=col ⍝ don't appear in ⎕MF
     ⍝ '→'=col ⍝ is a conditional →
     ⍝ '⊤'=col ⍝ next  statement is target of a branch
     ⍝ ':'=col ⍝ this  statement is target of a branch
     ⍝ '⊥'=col ⍝ above statement is target of a branch
      nc←nc↑¨⊂[1]CStable
     
      CS←nc,bv
    ∇

    ∇ NS
     ⍝ NOOP statement
    ∇

    ∇ r←{options}SSRDNETPATMATCH arg;⎕USING;CR;LF;syn;mo;np;len;ind;pattern;string;notalpha;mask;ls;lp;rs;⎕IO;Null;good;code;e;sl;ptr;regcomp;regerror;regexec;regfree;sxi;z;C;N;NULL
     ⍝ This function is used in conjunction with <ssrdnet> to find where the pattern is found.
     ⍝ It returns an int list indicating the start & length of each match.
     ⍝ Each subexpression specified is shown for each match (3D result).
     ⍝ This fn is ⎕io independent.
     ⍝ Pattern may not overlap.
     ⍝ ls/rs are left/right "syntactic" op. They work with 'notalpha' (see below).
     ⍝ 'mask' is where matches must occur entirely.
     ⍝
      arg←arg,(⍴arg)↓0 0 0 '' 0
      (pattern string notalpha mask syn)←,¨arg
      mask←mask,((0∊⍴mask)×⍴string)⍴1
      notalpha←notalpha∧1,mask,1
     
      ⎕IO←0 ⋄ N←'' ⋄ Null←⎕AV[0] ⋄ sl←'\'≠¯1↓'x',pattern
      ⎕SHADOW'⎕ml' ⋄ ⎕ML←0 ⋄ (CR LF)←⎕AV[3 2] ⍝∇∊DYW
      e←(⍴pattern)↑'∧'=1↑pattern ⍝ BOL anchor
      ((e∨¯1⌽sl∧'[∧'⍷pattern)/pattern)←⎕AV[235] ⍝ map ∧ to ASCII caret if no translation done
     
      good←e/⍳⍴e←sl∧'⍵'=pattern ⍝ numbers before ⍺ tokens
     ⍝ For APL code we accept ⍺ & ⍵ as shortcuts for 'object name' and 'number'
      :If 1∊e←sl∧'⍺'=pattern
          r←⎕NC 256 1⍴⎕AV ⋄ lp←,⎕AV[(⎕AV⍳'Aa')∘.+⍳26]
          r←0≤r ⍝ this varies from one APL to another
          r←'a-zA-Z',(r⌿⎕AV)~lp
          pattern[e/⍳⍴e]←⊂'(?>\b[',r,'][',r,'0-9]*\b|⍺⍺|⍺|⍵⍵|⍵)'
      :EndIf
      pattern[good]←⊂'(?>(?<!\w)¯?(?:\d+\.?\d*|\d*\.?\b\d+)(?:[eE]¯?\d+)?(?!\w))' ⍝ atomic grouping
      pattern←0⊃,,/pattern,⊂'' ⍝ cover empty case
      pattern←(~'\⍺'⍷e)/e←(~'\⍵'⍷e)/e←pattern
      r←1++/'('=pattern
      r←0⍴⊂(r,2)⍴0 ⍝ default result
     
     ⍝ Determine the options
      ⎕USING←'System.Text.RegularExpressions,system.dll'
      :If 0=⎕NC'options'
          options←RegexOptions.Multiline
      :EndIf
     
     ⍝ Mask out unwanted positions by using NL
      string[e/⍳⍴e←~mask]←LF
     
     ⍝ Change CR into NL if needed
      :If 'Multiline'≡⍕options
          string[e/⍳⍴e←string=CR]←LF
      :EndIf
     
      mo←Regex.Match string pattern options
     
     ⍝ Execute the expression until nothing found
      :While good←mo.Success
          (len ind)←mo.(Length Index)
          :If ∨/syn
     ⍝ notalpha is where no name forming chars are (padded 1 left and right to avoid INDEX error)
     ⍝ This supplements the ability of the engine to detect word characters with \w as Dyalog
     ⍝ also uses other characters like Á. 'notalpha' can indicate where those are.
              good←notalpha[len+0,ind]∧.≥syn
          :EndIf
          good←good∧∧/len↑ind↓mask
          :If good
              np←mo.Groups.Count
              r←r,⊂↑(mo.Groups.Item¨⍳np).(Index Length)
          :EndIf
          mo←mo.NextMatch
      :EndWhile
     
     end:
      r←↑r ⍝ disclose results
    ∇

    ∇ r←pattern txtpreplace string;⎕IO;N;from;to;i;ip;Tl;Fl;k;string;Fp;pos;sl;b;new;nosl;n;strs;rep
     ⍝ Text Pattern Replace
     ⍝ pattern is a 2 elements enclosed strings: what to look for, the replacement pattern
     ⍝ Ex: '(abc)(def)' '\2\1' will turn all 'abcdef' strings into 'defabc'
      (from to)←pattern ⋄ ⎕IO←0 ⋄ r←string
      (ip n)←2↑⍴pos←SSRDNETPATMATCH from string ⍝ this is a MxPx2
      →ip↓0 ⍝ any match?
      N←n↑'0123456789' ⋄ rep←ip⍴⊂to
      nosl←~1⌽b←(new∊N)∧¯1⌽'\'=new←to
     ⍝ Modify each occurence according to replacement pattern
      :If ∨/b
          :For i :In ⍳ip
              strs←pos[i;;1]↑¨pos[i;;0]↓¨⊂string ⋄ new←to
              (b/new)←strs[N⍳b/new] ⋄ rep[i]←,/nosl/new
          :EndFor
      :EndIf
     ⍝ Do it
      Tl←⊃,/⍴¨rep ⋄ Fl←pos[;0;1] ⋄ k←(Fp,⍴string)-0,Fl+Fp←pos[;0;0] ⋄ b←(2×⍴k)⍴1 0
      string←((,k,[0.1]Fl,0)/b)/string   ⍝ remove matches
      string←(b←(,k,[0.1]Tl,0)/b)\string ⍝ make room for the replacement
      string[(~b)/⍳⍴b]←⊃,/rep            ⍝ put them in
      r←string
    ∇

:EndNamespace